#include "DxLib.h" /* DXCuƂ֗ȋ@\g */
#include <math.h>  /* CɗpӂĂsin()cos()g */

int main()
{
    
    const int windowWidth  = 640;  /* ʂ̉ */
    const int windowHeight = 480;  /* ʂ̍ */
    
    const int numOfMyShot    = 10; /* @̒e */
    const int numOfEnemyShot =  8; /* G@̒e */

    enum shotStatus { /* ȅԂ\񋓌^萔̒` */
      kUnShot,   /* 0 : ˏ(e͉ʓɖ) */
      kShot      /* 1 : ˏ(e͉ʓɗL) */
    };

    struct Ship {    /* @G@Ȃǁu@́v\\ */
      int x, y;    /* W\tB[h x, y */
      int life;    /* Ct\int^̃tB[h life */
      int graphic; /* OtBbNԍ\int^̃tB[h graphic */
    };

    struct Ship myShip, eShip;
    
    /* ŏ̕`ʒuʂ̐^񒆂ɃZbg(ʃTCYwindowHeight x windowWidth) */
    myShip.x =  windowWidth/2 - 32/2;
    myShip.y = windowHeight/2 - 32/2;
    myShip.life = 5;
    myShip.graphic = 0;

    int keyInput;             /* L[͂̌ʂۑĂ߂̕ϐ */

    int bg     = 0; /* wiOtBbÑOtBbNԍLĂϐ */
    int i; /* JEg_E\forp̕ϐ */

    int shots_Life[numOfMyShot]; /* @̒e(kUnShot)ˍς(kShot)\ϐnumOfMyShot̔z */
    int shots_x[numOfMyShot];    /* @̒exW\ϐnumOfMyShot̔z */
    int shots_y[numOfMyShot];    /* @̒eyW\ϐnumOfMyShot̔z */
    int j; /* @̒e\Ăzforŏ邽߂̃JE^ϐ */
    int myShot = 0; /* @eOtBbÑOtBbNԍLĂϐ */

    /* G@̍ŏ̕`ʒuʂ̐^񒆏㕔ɃZbg */
    eShip.x = windowWidth/2 - 32/2;
    eShip.y = 0;
    eShip.life = 30;
    eShip.graphic = 0;

    int e_shots_Life[numOfEnemyShot]; /* G@̒e(kUnShot)ˍς(kShot)\ϐnumOfEnemyShot̔z */
    int e_shots_x[numOfEnemyShot];    /* G@̒exW\ϐnumOfEnemyShot̔z */
    int e_shots_y[numOfEnemyShot];    /* G@̒eyW\ϐnumOfEnemyShot̔z */
    int eShot    = 0;    /* G@eOtBbÑOtBbNԍLĂϐ */
    int eShot_Go = 0;    /* G@e𔭎˂ł邩ǂ(0̂Ƃ˕s\A1̎ˉ\) */

    int bg_scroll_y = 0; /* wiOtBbÑXN[ʒu */

    int bgm_sound   = 0; /* BGM̉f[^ԍLĂϐ */
    int shot_sound  = 0; /* e̔ˉf[^ԍLĂϐ */
    int eshot_sound = 0; /* G̒e̔ˉf[^ԍLĂϐ */
    int crash_sound = 0; /* ̉f[^ԍLĂϐ */
    int hit_sound   = 0; /* ẽqbgf[^ԍLĂϐ */
    int win_sound   = 0; /* BGM̉f[^ԍLĂϐ */

    int time = GetNowCount(); /* WindowsNĂ̎Ԃ~b̒Pʂœ */

    for( i = 0; i < numOfMyShot; i++ ) {
        shots_Life[ i ] = kUnShot; shots_x[ i ] = 0; shots_y[ i ] = 0;
    }
    for( i = 0; i < numOfEnemyShot; i++ ) {
        e_shots_Life[ i ] = kUnShot; e_shots_x[ i ] = 0; e_shots_y[ i ] = 0;
    }

    SetWindowSizeChangeEnableFlag( TRUE );
    SetGraphMode( windowWidth, windowHeight, 32  );

    eShip.graphic = LoadGraph(  "EnemyShip32.bmp" ); /* G@OtBbN(32pixels ~ 32pixels)̓ǂݍ */
    eShot = LoadGraph( "Chars16_blue.bmp" ); /* G@eOtBbN(16pixels ~ 16pixels)̓ǂݍ */

    myShot = LoadGraph( "Chars16_orange.bmp" ); /* @eOtBbN(16pixels~16pixels)̓ǂݍ */

    bgm_sound   = LoadSoundMem(  "ForGame008.mp3" ); /* BGMf[^̓ǂݍ */
    shot_sound  = LoadSoundMem(        "shot.mp3" ); /* e̔ˉf[^̓ǂݍ */
    eshot_sound = LoadSoundMem(       "eshot.mp3" ); /* G̒e̔ˉf[^̓ǂݍ */
    crash_sound = LoadSoundMem(       "crash.mp3" ); /* ̉f[^̓ǂݍ */
    hit_sound   = LoadSoundMem(         "hit.mp3" ); /* ẽqbgf[^̓ǂݍ */
    win_sound   = LoadSoundMem(         "win.mp3" ); /* BGM̉f[^̓ǂݍ */

    SetFontSize( 30 ); /* (tHg)̃TCY30ɐݒ */
    for( i = 3; i >= 0; i-- ) {
        ClsDrawScreen(); /* `ʂꂢɏ */
        /* liʂ̂(windowWidth/2, windowHeight/2)ɐFŕ\ */
        DrawFormatString( windowWidth/2, windowHeight/2, GetColor( 50, 50, 255 ), "%d", i ); 
        WaitTimer( 700 ); /* 700~bƂ߂ */
    }

    PlaySoundMem( bgm_sound, DX_PLAYTYPE_LOOP, TRUE ); /* BGMJԂĐJn */

    bg     = LoadGraph( "bg.jpg" );       /* wiOtBbN(windowWidthpixels ~ 600pixels)̓ǂݍ */
    myShip.graphic = LoadGraph( "MyShip32.bmp" ); /* @OtBbN(32pixels ~ 32pixels)̓ǂݍ */

    SetDrawScreen( DX_SCREEN_BACK );  /* `𗠉ʂɐݒ肷 */

    while( 1 ){ /* ɌJԂ([v) */
    
        ClsDrawScreen(); /* `ʂꂢɏ */
        
        /* wi`( XN[Ή ) */
        if( bg_scroll_y  < 0 ) bg_scroll_y = bg_scroll_y + 600;
        if( (bg_scroll_y + windowHeight) > 600 ) DrawRectGraph( 0, 600 - bg_scroll_y, 0, 0, windowWidth, bg_scroll_y + windowHeight - 600, bg, TRUE, FALSE );
        DrawRectGraph( 0, 0, 0, bg_scroll_y, windowWidth, 600 - bg_scroll_y, bg, TRUE, FALSE );
        bg_scroll_y = bg_scroll_y - 2;

        keyInput = GetJoypadInputState( DX_INPUT_KEY_PAD1 ); /* L[{[h̓͂ϐkeyInput֕ۑ */
        if( keyInput == PAD_INPUT_RIGHT ) { /* EL[Ăʂ̉EɎ@oȂ悤ɂ */
            if( (myShip.x + 5) >= ((windowWidth - 1)-31) ) {
                myShip.x = ((windowWidth - 1)-31);
            }
            else {
                myShip.x = myShip.x + 5;
            }
        }
        if( keyInput == PAD_INPUT_LEFT  ) { /* L[Ăʂ̍Ɏ@oȂ悤ɂ */
            if( (myShip.x - 5) <= 0 ) {
                myShip.x = 0;
            }
            else {
                myShip.x = myShip.x - 5;
            }
        }
        if( keyInput == PAD_INPUT_DOWN  ) {
            if( (myShip.y + 5) >= ((windowHeight - 1) - 31) ) {
                myShip.y = ((windowHeight - 1) - 31);
            }
            else {
                myShip.y = myShip.y + 5;
            }
        }
        if( keyInput == PAD_INPUT_UP    ) {
            if( (myShip.y + 5) <= 0 ) {
                myShip.y = 0;
            }
            else {
                myShip.y = myShip.y - 5;
            }
        }
        
        /* L[{[h͂ꂽXy[XȂ玩@e */
        if( GetInputChar( TRUE ) == ' ' && (GetNowCount() - time)>= 10000 ) { /* GetInputChar(TRUE)DXCű@\ŃL[{[hŉ͂ */
            for( j = 0; j < numOfMyShot; j++ ) {
                if( shots_Life[j] == kUnShot ) { /* ˂̒e... */
                    shots_Life[j] = kShot;     /* ˍς݂ɂ */
                    shots_x[j] = myShip.x + (32/2) - (16/2); /* exW@̕@ɐݒ肷 */
                    shots_y[j] = myShip.y;                   /* eyW@̕@ɐݒ肷 */
                    PlaySoundMem( shot_sound, DX_PLAYTYPE_BACK, TRUE ); /* e̔ˉĐ */
                    break; /* ˂e1ł̂ŁAJԂIɏI */
                }
            }
        }

        for( j = 0; j < numOfMyShot; j++ ) { /* @̒enumOfMyShotɑ΂Ď̏s */
            if( shots_y[j]+16 < 0 ) shots_Life[j] = kUnShot; /* ʂяoe͖ˏԂɂ */
            if( shots_Life[j] != kUnShot ) {              /* @jԖڂ̒eˍς݂Ȃ... */
                DrawGraph( shots_x[j], shots_y[j], myShot, TRUE ); /* @jԖڂ̒eʂɕ`悷 */
                shots_y[j] = shots_y[j] - 8;        /* ̕`掞̂߂jԖڂ̒ëʒuOɐi߂ */
            }
        }


        eShot_Go = 1; /* Ƃ肠ˉ\ԂɂĂ */
        for( j = 0; j < numOfEnemyShot; j++ ) {
            if( e_shots_x[j]    < 0   ) e_shots_Life[j] = kUnShot; /* ʂяoe͖ˏԂɂ */
            if( e_shots_x[j]+16 > (windowWidth - 1) ) e_shots_Life[j] = kUnShot; /* ʂяoe͖ˏԂɂ */
            if( e_shots_y[j]+16 < 0   ) e_shots_Life[j] = kUnShot; /* ʂяoe͖ˏԂɂ */
            if( e_shots_y[j]    > (windowHeight - 1) ) e_shots_Life[j] = kUnShot; /* ʂяoe͖ˏԂɂ */
            if( e_shots_Life[j] != kUnShot ) eShot_Go = 0; /* numOfEnemyShot̒ê1łˍςȂ甭˕s\Ƃ */
        }
        if( eShot_Go == 1 ) { /* G@̒eˉ\ȂSĂ̒e𔭎ˍς݂ɂĈʒuZbg */
            for( j = 0; j < numOfEnemyShot; j++ ) {
                e_shots_Life[j] = kShot;
                e_shots_x[j] = (eShip.x + 16 - 8); e_shots_y[j] = (eShip.y + 16 - 8);
            }
            PlaySoundMem( eshot_sound, DX_PLAYTYPE_BACK, TRUE ); /* G̒e̔ˉĐ */
        }

        for( j = 0; j < numOfEnemyShot; j++ ) { /* G@̒êAˍς݂̒e`悷B */
            if( e_shots_Life[j] != kUnShot ) {
                DrawGraph( e_shots_x[j], e_shots_y[j], eShot, TRUE ); /* G@ẽOtBbN`悷 */
            }
            /* ̕`掞̂߂jԖڂ̒ëʒuOɐi߂ */
            e_shots_x[j] = e_shots_x[j] + 6 * cos( j * ((2.0/numOfEnemyShot) * 3.1415926) );
            e_shots_y[j] = e_shots_y[j] + 6 * sin( j * ((2.0/numOfEnemyShot) * 3.1415926) );
        }

        DrawGraph( eShip.x, eShip.y, eShip.graphic, TRUE ); /* Wex,eyɓG@̃OtBbN`悷 */
        /* G@̍W_Ɏ@ɋ߂ÂBȂAGetRand(n)́A0n܂ł̂ł߂ȒlԂ */
        eShip.x = eShip.x + (myShip.x - eShip.x)/( GetRand(200) + 15 );  eShip.y = eShip.y + (myShip.y - eShip.y)/( GetRand(200) + 15 );


        DrawGraph( myShip.x, myShip.y, myShip.graphic, TRUE ); /* Wx,yɎ@̃OtBbN`悷 */

        /* Փ˔s */
        /* Փ˔PDu@ƓG@v */
        if( (( myShip.x <= eShip.x) && ( eShip.x <= (myShip.x + 31))) && (( myShip.y <= eShip.y) && ( eShip.y <= (myShip.y + 31))) ) {
            PlaySoundMem( crash_sound, DX_PLAYTYPE_BACK, TRUE ); /* Đ */
            myShip.life = 0; /* @̃Ct0ɐݒ */
        }

        /* Փ˔QDu@̒eƓG@v */
        for( i = 0; i < numOfMyShot; i++ ) {
            if( shots_Life[i] != kUnShot ) { /* ˏԂ̒eɊւĂG@Ƃ̏Փ˔ */
                if(
                    ( (eShip.x <= shots_x[i]) && (shots_x[i] <= (eShip.x + 31) ) && 
                    ( (eShip.y <= shots_y[i]) && (shots_y[i] <= (eShip.y + 31) ) ))
                  ) {
                    shots_Life[i] = kUnShot; /* e𖢔ˏԂɂ */
                    PlaySoundMem( hit_sound, DX_PLAYTYPE_BACK, TRUE ); /* ẽqbgĐ */
                    eShip.life = eShip.life - 1; /* G@̃Ct1炷 */
                }
            }
        }

        /* Փ˔RDuG@̒eƎ@v */
        for( i = 0; i < numOfEnemyShot; i++ ) {
            if( e_shots_Life[i] != kUnShot ) { /* ˏԂ̒eɊւĂ@Ƃ̏Փ˔ */
                if(
                    ( (myShip.x <= e_shots_x[i]) && (e_shots_x[i] <= (myShip.x + 31) ) && 
                    ( (myShip.y <= e_shots_y[i]) && (e_shots_y[i] <= (myShip.y + 31) ) ))
                  ) {
                    e_shots_Life[i] = kUnShot; /* e𖢔ˏԂɂ */
                    PlaySoundMem( hit_sound, DX_PLAYTYPE_BACK, TRUE ); /* ẽqbgĐ */
                    myShip.life = myShip.life - 1; /* @̃Ct1炷 */
                }
            }
        }

        /* CtƌoߎԂ̕\ */
        DrawFormatString( 0, 0, GetColor( 20, 20, 255 ), "%02d", myShip.life );
        DrawFormatString( windowWidth - GetDrawFormatStringWidth( "%02d", eShip.life ), 0, GetColor( 255, 0, 0 ), "%02d", eShip.life );
        DrawFormatString( windowWidth/2 - ( GetDrawFormatStringWidth( "%03.2f", (GetNowCount() - time) / 1000.0 ) ) / 2, 
                         2 , GetColor( 255, 255, 0 ), "%03.2f", (GetNowCount() - time) / 1000.0 );

        /* ܂疳[v甲o */
        if( eShip.life <= 0 || myShip.life <= 0 ) break;


        ScreenFlip(); /* ʂɕ`悵̂\ʂɓ]ʂ */


        if( CheckHitKey(KEY_INPUT_ESCAPE) ) break; /* GXP[vL[ꂽJԂo */
    } /* while()̕ */


    SetDrawScreen( DX_SCREEN_FRONT ); /* `\ʂɂ */

    /* vC[ꍇ */
    if( eShip.life <= 0 ) {
        PlaySoundMem( crash_sound, DX_PLAYTYPE_BACK, TRUE ); /* Đ */
        StopSoundMem( bgm_sound ); /* BGMĐ~ */
        PlaySoundMem( win_sound, DX_PLAYTYPE_LOOP, TRUE ); /* BGM[vĐ */
        SetFontSize( 60 ); /* tHgTCY60ɐݒ */
        DrawFormatString( windowWidth/2 - (GetDrawFormatStringWidth( "You Win!!" ) / 2 ), 
                          windowHeight/2 - 20, GetColor( 20, 20, 255 ), "You Win!!" );
    }

    /* vC[ꍇ */
    if( myShip.life <= 0 ) {
        PlaySoundMem( crash_sound, DX_PLAYTYPE_BACK, TRUE ); /* Đ */
        SetFontSize( 60 ); /* tHgTCY60ɐݒ */
        DrawFormatString( windowWidth/2 - (GetDrawFormatStringWidth( "You Lose!!" ) / 2 ), 
                          windowHeight/2 - 20, GetColor( 255, 100, 100 ), "You Lose!!" );
    }

    while( CheckHitKey( KEY_INPUT_ESCAPE ) == 0 ) {} /* GXP[vL[̂҂ */

    return 0;
}
